## ponyprog 3.1.2+ds

=== CMakeLists.txt ===
PROJECT(ponyprog)

# Configure CMake ...
CMAKE_MINIMUM_REQUIRED(VERSION 2.8 FATAL_ERROR)
# CMAKE_POLICY(SET CMP0003 OLD)
# CMAKE_POLICY(SET CMP0015 OLD)

# set the Qt version to 4 or 5
OPTION (USE_QT5 "Using of Qt5 version for compiling" ON)

IF(${USE_QT5})
    SET(USE_QT_VERSION 5)
ELSE(${USE_QT5})
    SET(USE_QT_VERSION 4)
ENDIF(${USE_QT5})

# # SET(FILES_TO_TRANSLATE)
IF(WIN32)
    IF(MSVC)
        SET (CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH}:${QTDIR}\\msvc2015\\")
    ENDIF()

    IF(MinGW)
        SET (CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH}:${QTDIR}\\mingw53_32\\")
    ENDIF()
ENDIF()

#disable -rdynamic
# SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
# SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")


# FILE (GLOB TRANSLATIONS_FILES ${CMAKE_CURRENT_SOURCE_DIR}/translations/*.ts)

# OPTION (UPDATE_TRANSLATIONS "Update source translation ${CMAKE_CURRENT_SOURCE_DIR}/translations/*.ts" OFF)


MESSAGE(STATUS "Qt version for compiling: " ${USE_QT_VERSION})

OPTION (USE_DEBUGGER "Include in binary file debug information" OFF)

OPTION (USE_PROFILER "Include in binary file profiling information" OFF)


IF(${USE_DEBUGGER})
  SET(CMAKE_BUILD_TYPE Debug)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_DEBUG} -Wall")
ELSE()
  SET(CMAKE_BUILD_TYPE Release)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_RELEASE} -Wall")
ENDIF()

MESSAGE(STATUS "CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS}")

INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(TestCXXAcceptsFlag)
INCLUDE(CheckCXXCompilerFlag)


SET(TARGET_NAME ponyprog )
SET(CMAKE_HELPERS_BINARY_DIR ${PROJECT_SOURCE_DIR}/cmake)
SET(CMAKE_HELPERS_SOURCE_DIR ${PROJECT_SOURCE_DIR}/cmake)
LIST(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")



INCLUDE(OutOfSourceBuild) # Disallow in-source builds

INCLUDE(GenerateDEF) # Convenience macro for linking Win32 DLLs using MSVC
INCLUDE(Dependencies)


SET(CURRENT_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})

INCLUDE(FindLibUSB-1.0)


IF(NOT ${LIBUSB_VERSION} LESS "1.0.16")
  MESSAGE(STATUS "LibUSB version ${LIBUSB_VERSION}")
ELSE()
  MESSAGE(FATAL_ERROR "-- LibUSB version ${LIBUSB_VERSION} TOO OLD! Please Install this library newer as 1.0.16")
ENDIF()


# Set the PonyProg version
# this for generating of version file from HISTORY file
# the idea is to descript all changes in this file, the ne changes are in the top of file
FILE(READ "HISTORY" DESCRIBE_STRING)
STRING(REGEX MATCH "([0-9]+\\.[0-9]+\\.[0-9]+)" APP_VERSION "${DESCRIBE_STRING}" )

MESSAGE(STATUS "Version info: ${APP_VERSION}") 
SET(VERSION ${APP_VERSION})

# 
# SET(APP_VERSION "3.0.0")
SET(APP_AUTHOR "Claudio Lanconelli")
SET(APP_EMAIL "PonyProg2000@gmail.com")
SET(APP_NAME "PonyProg")

IF(WIN32)
  EXECUTE_PROCESS (
    COMMAND "cmd" " /c date /t"
    OUTPUT_VARIABLE APP_BUILD_DATE
    OUTPUT_STRIP_TRAILING_WHITESPACE)
ELSE()
  EXECUTE_PROCESS (
    COMMAND date +"%d.%m.%Y"
    OUTPUT_VARIABLE APP_BUILD_DATE
    OUTPUT_STRIP_TRAILING_WHITESPACE)
    STRING(REGEX REPLACE "\"" "" APP_BUILD_DATE ${APP_BUILD_DATE})
ENDIF()

MESSAGE(STATUS "Version build date: ${APP_BUILD_DATE}")

# 
SET(PONYPROG_PACKAGE ponyprog)
SET(PONYPROG_HOST ${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR})
SET(PONYPROG_COPYRIGHT "Copyright (c) 1997-2021   ${APP_AUTHOR}, All Rights Reserved.")
SET(PONYPROG_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

# Setup high-level build options
# IF(MSVC)
#   SET(PONYPROG_ENABLE_SYMBOL_VISIBILITY_DEFAULT ON)
# ELSE(MSVC)
#   SET(PONYPROG_ENABLE_SYMBOL_VISIBILITY_DEFAULT OFF)
# ENDIF(MSVC)

IF (CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.7)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -fno-exceptions")
ELSE()
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-exceptions")
ENDIF()


# options for gprof 
IF(${USE_PROFILER})
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -pg")
  # after execution of program: gprof ./build/ponyprog
  # and get the information from gprof.txt file
  MESSAGE(STATUS "Compile with profiling information")
ELSE()
  MESSAGE(STATUS "Compile without profiling information")
ENDIF()



IF(${USE_QT_VERSION} MATCHES "4")
    SET(HAVE_QT_PRINTSUPPORT true)
    FIND_PACKAGE(Qt4 COMPONENTS QtCore QtGui REQUIRED)

    IF(NOT QT4_FOUND)
        MESSAGE(FATAL_ERROR "Qt4 could not be found. "
        "If it's INSTALLed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
        "You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax.")
    ENDIF()
ELSE()
    FIND_PACKAGE(Qt5 COMPONENTS Core PrintSupport Gui Widgets Multimedia REQUIRED QUIET)

    IF(NOT Qt5Widgets_FOUND)
        MESSAGE(FATAL_ERROR "Qt5 could not be found. "
        "If it's INSTALLed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
        "You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax.")
    ENDIF(NOT Qt5Widgets_FOUND)

    IF(NOT Qt5PrintSupport_FOUND)
        MESSAGE(FATAL_ERROR "Qt5 PrintSupport development files are not found. "
        "Qt5PrintSupport development package is to install.")
    ENDIF(NOT Qt5PrintSupport_FOUND)

    IF(NOT Qt5Multimedia_FOUND)
        MESSAGE(FATAL_ERROR "Qt5 Multimedia development files are not found. "
        "Qt5Multimedia development package is to install.")
    ENDIF(NOT Qt5Multimedia_FOUND)
ENDIF()

#set ( FTDIPP ON )
FIND_PACKAGE ( LibFTDI1 NO_MODULE REQUIRED )

IF(NOT LibFTDI1_FOUND)
    MESSAGE(FATAL_ERROR "LibFTDI1 files are not found. "
    "LibFTDI1 and LibFTDIPP1 development packages are to install.")
ENDIF(NOT LibFTDI1_FOUND)

INCLUDE ( ${LIBFTDI_USE_FILE} )

# for this feature install debhelper or 
SET(PONYPROG_CPACK_PACKAGE_SHLIBDEPS ON)

IF(${USE_QT_VERSION} MATCHES "4")
    INCLUDE_DIRECTORIES(${QT_INCLUDES} ${LIBUSB_INCLUDE_DIRS})
    MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES}")
ELSE()
    INCLUDE_DIRECTORIES(${QT_INCLUDES} ${Qt5Widgets_INCLUDE_DIRS}  ${Qt5PrintSupport_INCLUDE_DIRS} ${Qt5Multimedia_INCLUDE_DIRS} ${LIBUSB_INCLUDE_DIRS})

    MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES} ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Multimedia_INCLUDE_DIRS}")

    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} ${Qt5Multimedia_EXECUTABLE_COMPILE_FLAGS} ${Qt5PrintSupport_EXECUTABLE_COMPILE_FLAGS}")
ENDIF()


configure_file (
  "${PROJECT_SOURCE_DIR}/SrcPony/version-cmake.h.in"
  "${PROJECT_SOURCE_DIR}/SrcPony/version.h" )


SET ( OBJECTS_DIR temp )
SET ( MOC_DIR temp )
SET ( UI_HEADERS_DIR temp )
SET ( UI_SOURCES_DIR temp )

ADD_SUBDIRECTORY(qhexedit2/src)
ADD_SUBDIRECTORY(SrcPony)

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/qhexedit2/src/ ${CMAKE_CURRENT_SOURCE_DIR}/SrcPony/ )


IF(${USE_QT_VERSION} MATCHES "4")
#     QT4_ADD_TRANSLATION(APP_TRANSLATIONS ${TRANSLATION})
    QT4_WRAP_CPP(APP_HEADERS_MOC ${HEX_HEADERS} ${PONY_HEADERS} )
    QT4_WRAP_UI(APP_FORMS_HEADERS ${PONY_FORMS} )
    QT4_ADD_RESOURCES(APP_RESOURCES_RCC ${APP_RESOURCES})
ELSE()
#     QT5_ADD_TRANSLATION(APP_TRANSLATIONS ${TRANSLATION})
    QT5_WRAP_CPP(APP_HEADERS_MOC ${HEX_HEADERS} ${PONY_HEADERS} )
    QT5_WRAP_UI(APP_FORMS_HEADERS ${PONY_FORMS} )
    QT5_ADD_RESOURCES(APP_RESOURCES_RCC ${APP_RESOURCES})
ENDIF()


MESSAGE(STATUS "PONY_RESOURCES ${APP_RESOURCES_RCC}")

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

SOURCE_GROUP( "Generated Files" FILES
    ${MOC_FILES_CPP}
    ${APP_FORMS_HEADERS}
    ${APP_RESOURCES_RCC}
)


IF(NOT ${USE_DEBUGGER})
    ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_NO_DEBUG_OUTPUT -DQT_NO_DEBUG -DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)
ELSE()
    ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_DEBUG)
ENDIF()


IF(${USE_QT_VERSION} MATCHES "4")
    INCLUDE(${QT_USE_FILE})
    ADD_DEFINITIONS(${QT_DEFINITIONS} -DNO_QT3SUPPORT -DDISABLE_QT3SUPPORT -DQT_PROJECT)
ELSE()
    ADD_DEFINITIONS(${Qt5Widgets_DEFINITIONS} ${Qt5PrintSupport_DEFINITIONS} ${Qt5Multimedia_DEFINITIONS} -DQT_PROJECT)
ENDIF()

IF(WIN32)
    ADD_DEFINITIONS(-DUNICODE -D_UNICODE)
ENDIF()



ADD_EXECUTABLE(${CMAKE_PROJECT_NAME}
    ${APP_SOURCES} 
    ${HEX_SOURCES}
    ${PONY_SOURCES}
    ${APP_HEADERS_MOC} 
    ${APP_FORMS_HEADERS} 
#     ${APP_TRANSLATIONS}
    ${APP_RESOURCES_RCC}
)


IF(${USE_QT_VERSION} MATCHES "4")
  TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} ${LIBUSB_LIBRARIES})
ELSE()
  TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES} ${LIBUSB_LIBRARIES})
  MESSAGE(STATUS "QT LIBRARIES: ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES} ${Qt5Core_LIBRARIES}")
ENDIF()

#target_link_libraries(${CMAKE_PROJECT_NAME} ${LIBFTDI_LIBRARIES} )
target_link_libraries(${CMAKE_PROJECT_NAME} ftdipp1 ${LIBFTDI_LIBRARIES} )

ADD_CUSTOM_TARGET (tags
    COMMAND  ctags -R -f tags ${CMAKE_SOURCE_DIR}/SrcPony
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)


# Setup module enabled/disabled defaults ...
IF(MSVC)
    SET(PONYPROG_BUILD_GLX_MODULE_DEFAULT ON)
    SET(PONYPROG_BUILD_OSX_MODULE_DEFAULT OFF)
    SET(PONYPROG_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(MSVC)

IF(UNIX AND NOT APPLE)
    SET(PONYPROG_BUILD_GLX_MODULE_DEFAULT ON)
    SET(PONYPROG_BUILD_OSX_MODULE_DEFAULT OFF)
    SET(PONYPROG_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(UNIX AND NOT APPLE)

IF(APPLE)
    SET(PONYPROG_BUILD_GLX_MODULE_DEFAULT ON)
    SET(PONYPROG_BUILD_OSX_MODULE_DEFAULT ON)
    SET(PONYPROG_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(APPLE)


OPTION(PONYPROG_ENABLE_SYMBOL_VISIBILITY "Minimize the number of symbols exported from shared libraries." ${PONYPROG_ENABLE_SYMBOL_VISIBILITY_DEFAULT})
MARK_AS_ADVANCED(PONYPROG_ENABLE_SYMBOL_VISIBILITY)

# OPTION(PONYPROG_ENABLE_TESTING "Build the Ponyprog regression test suite." OFF)
# SET(BUILD_TESTING ${PONYPROG_ENABLE_TESTING} CACHE INTERNAL "" FORCE)
# INCLUDE(CTest)
# MARK_AS_ADVANCED(DART_TESTING_TIMEOUT)
# IF(PONYPROG_ENABLE_TESTING)
#     CMAKE_MINIMUM_REQUIRED(VERSION 2.6.1 FATAL_ERROR)
#     CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/CTestCustom.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake @ONLY)
# ENDIF(PONYPROG_ENABLE_TESTING)

# Capture system configuration
INCLUDE(SystemConfiguration)

# MSVC configuration
IF(MSVC)
    IF(NOT MSVC)
        SET(CMAKE_EXE_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc" CACHE STRING "" FORCE)
        SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,--enable-runtime-pseudo-reloc -Wl,--export-all-symbols" CACHE STRING "" FORCE)
    ENDIF(NOT MSVC)
ENDIF(MSVC)

# Setup output directories ...
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PONYPROG_BINARY_DIR}/bin)


IF(MSVC)
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PONYPROG_BINARY_DIR}/bin)
ELSE(MSVC)
    SET(PONYPROG_LIBDIR lib) # Allows us to handle 64-bit libs if/when it becomes necessary.
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PONYPROG_BINARY_DIR}/${PONYPROG_LIBDIR})
ENDIF(MSVC)

# Setup a macro for compiling resources ...
MACRO(PONYPROG_COMPILE_RESOURCE OUTPUT INPUT RESOURCE_PATH)

    SET(INPUT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/${INPUT}")
    SET(OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/${INPUT}.cpp")
    GET_FILENAME_COMPONENT(OUTPUT_PATH ${OUTPUT_FILE} PATH)

    GET_TARGET_PROPERTY(PONYPROG_RESOURCE_COMPILER ponyprog-resource-compiler LOCATION)

    ADD_CUSTOM_COMMAND(
        DEPENDS ponyprog-resource-compiler
        DEPENDS ${INPUT_FILE}
        COMMAND ${CMAKE_COMMAND} -E make_directory ${OUTPUT_PATH}
        COMMAND ${PONYPROG_RESOURCE_COMPILER} --input ${INPUT_FILE} --path \"<path>${RESOURCE_PATH}</path>\" --output ${OUTPUT_FILE}
        OUTPUT ${OUTPUT_FILE}
        COMMENT "Compiling resource ${INPUT_FILE}"
        )

    LIST(APPEND ${OUTPUT} ${OUTPUT_FILE})

ENDMACRO(PONYPROG_COMPILE_RESOURCE)

# Setup subdirectories ...

=== distribution/CMakeLists.txt ===
# Setup automatic generation of the changelog
MESSAGE(STATUS "Generate installation variables..." )
ADD_CUSTOM_TARGET(changelog
	COMMAND ${HGCOMMAND} log > ${PONYPROG_BINARY_DIR}/ChangeLog
	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
	)


SET( CPACK_SOURCE_PACKAGE_FILE_NAME "ponyprog-${APP_VERSION}" )



# --- Package generation
# SET( CPACK_BUILD_CONFIG "Release_and_Debug" )
# SET( CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
SET( CPACK_PACKAGE_VENDOR "Lancos" )
SET( CPACK_PACKAGE_INSTALL_DIRECTORY "PONYPROG ${APP_VERSION}" )
SET( CPACK_PACKAGE_INSTALL_REGISTRY_KEY "PONYPROG ${APP_VERSION}" )
SET( CPACK_PACKAGE_HOMEPAGE "http://ponyprog.sourceforge.net/" )


# Setup global packaging parameters ...
SET( PONYPROG_CPACK_INSTALL_CMAKE_PROJECTS "${CURRENT_BUILD_DIR};ponyprog;ALL;/" )
# MESSAGE("PONYPROG_BINARY_DIR ${CURRENT_BUILD_DIR}")
# SET( PONYPROG_CPACK_PACKAGE_DESCRIPTION "Ponyprog free GUI for EEPROM and microcontroller flashing." )
SET( PONYPROG_CPACK_PACKAGE_FILE_NAME "ponyprog-setup-${APP_VERSION}" )
SET( PONYPROG_CPACK_PACKAGE_VERSION "${APP_VERSION}" )
SET( PONYPROG_CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE" )

SET( PONYPROG_CPACK_SOURCE_INSTALLED_DIRECTORIES "${PROJECT_SOURCE_DIR};/" )
SET( PONYPROG_CPACK_SOURCE_PACKAGE_FILE_NAME "ponyprog-source-${APP_VERSION}" )
SET( PONYPROG_CPACK_SOURCE_IGNORE_FILES
    "/\\\\.svn/"
    "/\\\\.kdev4/*"
    "/\\\\.git/*"
    "/pics/"
    "/build*/*"
    "\\\\.deb"
    "\\\\.rpm"
    "\\\\.zip"
    "\\\\.kdev4"
    "/cppreport"
    "/ponyprog$"
#     "~$"
#     "/ponyprog"
#     "TODO.txt"
#     "CMakeLists.txt.user"
#     "/doxygen/"
#     "${CMAKE_BINARY_DIR}"
)

SET( PONYPROG_CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME} )
# SET( PONYPROG_CPACK_PACKAGE_VERSION ${APP_VERSION} )
SET( PONYPROG_CPACK_PACKAGE_RELEASE 0 )
SET( PONYPROG_CPACK_PACKAGE_MAINTAINER "${APP_AUTHOR} <${APP_EMAIL}>" )
SET( PONYPROG_CPACK_PACKAGE_MAINTAINER_NAME "${APP_AUTHOR}" )
SET( PONYPROG_CPACK_PACKAGE_MAINTAINER_EMAIL "${APP_EMAIL}" )
SET( PONYPROG_CPACK_PACKAGE_DESCRIPTION "EEPROM and microcontroller flasher" )
SET( PONYPROG_CPACK_PACKAGE_DESCRIPTION_SUMMARY "EEPROM and microcontroller flasher for PIC, Atmega and other chips" )
# SET( PACKAGE_DEPENDS ${hugr_dependencies} )

SET( PONYPROG_CPACK_PACKAGE_DEPENDS "${PONYPROG_CPACK_PACKAGE_SHLIBDEPS}" )
#SET( PONYPROG_CPACK_PACKAGE_DEPENDS "libusb-1.0-0, libftdi1-2, libftdipp1-3, libqt5core5a, libqt5gui5, libqt5widgets5, libqt5multimedia5, libqt5printsupport5" )

# SET( PACKAGE_DEPENDS "libc6 (>= 2.1.3), libqtcore4 (>= 4:4.6.1), libqtgui4 (>= 4:4.5.3), libstdc++6 (>= 4.1.1)" )


# SET( PONYPROG_CPACK_PACKAGE_GROUP "Groupe" )
SET( PONYPROG_CPACK_PACKAGE_LICENSE "GPL2" )

# ADD_CUSTOM_TARGET(changelog
# 	COMMAND ${GITCOMMAND} log > ${PONYPROG_BINARY_DIR}/ChangeLog
# 	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
# 	)

# Setup convenience targets for tagging and branching
# SET( PONYPROG_VERSION_TAG "ponyprog-${PONYPROG_MAJOR_VERSION}.${PONYPROG_MINOR_VERSION}.${PONYPROG_RELEASE_VERSION}.${PONYPROG_BUILD_VERSION}" )
# SET( PONYPROG_VERSION_TAG "ponyprog-${PONYPROG_VERSION}" )
# ADD_CUSTOM_TARGET(tag-version
# 	COMMAND ${GITCOMMAND} tag ${PONYPROG_VERSION_TAG}
# 	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
# 	)

#SET( PONYPROG_BRANCH_TAG "ponyprog-release-${PONYPROG_MAJOR_VERSION}.${PONYPROG_MINOR_VERSION}" )
#ADD_CUSTOM_TARGET(tag-branch
#	COMMAND ${SVNCOMMAND} cp ${PONYPROG_SVN_TRUNK}
#	${PONYPROG_SVN_BRANCHES}/${PONYPROG_BRANCH_TAG} -m "COMP: Branched PONYPROG Version ${PONYPROG_MAJOR_VERSION}.${PONYPROG_MINOR_VERSION}"
#	WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
#	)
# MESSAGE("CMAKE_CURRENT_SOURCE_DIR distr ${CMAKE_CURRENT_SOURCE_DIR} : ${PROJECT_SOURCE_DIR}")
# Get a SourceForge username so we can upload distributables to the FRS
# IF(WIN32)
# 	SET( PONYPROG_SOURCEFORGE_USERNAME "$ENV{USERNAME}" CACHE STRING "SourceForge user account name, for uploading distribution files." )
# ELSE(WIN32)
# 	SET( PONYPROG_SOURCEFORGE_USERNAME "$ENV{USER}" CACHE STRING "SourceForge user account name, for uploading distribution files." )
# ENDIF(WIN32)
# MARK_AS_ADVANCED(PONYPROG_SOURCEFORGE_USERNAME)



# Setup some macros that can be used by the platform-specific distribution logic
MACRO(PONYPROG_CHECK_INSTALLED_VERSION FOUND PACKAGE EXPECTED)
	IF(NOT ${FOUND} STREQUAL ${EXPECTED})
		MESSAGE(SEND_ERROR "Found ${PACKAGE} version ${FOUND} - for installation, version ${EXPECTED} is required." )
	ENDIF(NOT ${FOUND} STREQUAL ${EXPECTED})
ENDMACRO(PONYPROG_CHECK_INSTALLED_VERSION)

# IF(UNIX AND NOT APPLE)
#     SET(CPACK_STRIP_FILES TRUE)
# 
#     SET(CPACK_SET_DESTDIR "ON")
#     SET(CPACK_INSTALL_PREFIX "/usr") 
#     SET(CPACK_PACKAGE_INSTALL_DIRECTORY "/usr")
# ENDIF(UNIX AND NOT APPLE)

# Generate source packages
ADD_SUBDIRECTORY(source)

# Generate platform-specific binary packages
IF(APPLE)
	ADD_SUBDIRECTORY(osx)
ENDIF(APPLE)

IF(UNIX AND NOT APPLE)
	ADD_SUBDIRECTORY(posix)
ENDIF(UNIX AND NOT APPLE)

IF(WIN32)
	ADD_SUBDIRECTORY(win32)
ENDIF(WIN32)


# INCLUDE(CPack)

=== distribution/win32/CMakeLists.txt ===
# add the inno subdir

ADD_SUBDIRECTORY(inno)
ADD_SUBDIRECTORY(nsis)

=== distribution/osx/packagemaker/CMakeLists.txt ===
# The CPack PackageMaker generator ignores CMAKE_INSTALL_PREFIX and places everything in /usr, complain if there is a mismatch
IF(NOT "${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr")
       MESSAGE(SEND_ERROR "PONYPROG_CREATE_PACKAGEMAKER_PACKAGE requires CMAKE_INSTALL_PREFIX set to \"/usr\".")
ENDIF(NOT "${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr")

# Generate a packagemaker package ...
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/LICENSE ${CMAKE_CURRENT_BINARY_DIR}/COPYING.txt COPYONLY)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-packagemaker.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-packagemaker.cpack)

ADD_CUSTOM_TARGET(package-binary-packagemaker
	${CMAKE_CPACK_COMMAND}
	--config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-packagemaker.cpack
	)

=== distribution/win32/inno/CMakeLists.txt ===
# Generate InnoSetup installer
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-inno.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-inno.cpack)
ADD_CUSTOM_TARGET(package-binary-inno
	${CMAKE_CPACK_COMMAND}
	--config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-inno.cpack
	)

=== debian/changelog ===
ponyprog (3.1.2+ds-1) unstable; urgency=medium

  * [cdb37bf] New upstream version 3.1.2+ds
  * [7278056] d/copyright: update copyright years
  * [4005b58] d/README.source: update SHA ID for additional tarball
    The source for the additional tarball is based now on different SHA commit
    id.
  * [731a9e5] d/control: increase Standards-Version to 4.5.1
    No further changes needed.
  * [33af4ba] dh: move over to debhelper-compat 13
  * [8531dac] d/rules: convert ponyprog.html to utf-8 if needed

 -- Carsten Schoenert <c.schoenert@t-online.de>  Thu, 21 Jan 2021 20:02:39 +0100

=== debian/control ===
Source: ponyprog
Section: utils
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
Uploaders:
 Carsten Schoenert <c.schoenert@t-online.de>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 graphicsmagick-imagemagick-compat,
 libftdi1-dev,
 libftdipp1-dev,
 libusb-dev,
 qtbase5-dev,
 qtmultimedia5-dev,
Standards-Version: 4.5.1
Homepage: https://github.com/lancos/ponyprog
Vcs-Browser: https://salsa.debian.org/electronics-team/ponyprog
Vcs-Git: https://salsa.debian.org/electronics-team/ponyprog.git

Package: ponyprog
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Serial device programmer
 PonyProg is a serial device programmer software with a user friendly
 GUI framework available for Windows and Linux. It's purpose is reading
 and writing every serial device. With PonyProg and SI-Prog you can
 program Wafercard for SAT, eeprom within GSM, TV or CAR-RADIO.
 Furthermore it can be used as a low cost starter kit for PIC and AVR.
 .
 Ponyprog supports AVR, SPI eeprom, AVR micro, 12C bus 8bit eeprom, PIC 
 16 micro, PIC 12 micro, AT89S micro and SDE2506 eeprom family chips.
 .
 You can open any HEX, e2p, mot, csm, rom, eep, bin files and burn them
 to uC or PIC. You can even backup the old program on the chip using
 Ponyprog. Ponyprog enables the user to write, verify and erase data on
 the microchip.
 .
 Also setting fuse bits and locks using Ponyprog is possible. You can
 save any HEX file to BIN file or eep file, BIN file to HEX file or MOT
 file and vice versa so you can use Ponyprog as converter too. Ponyprog
 offers serial or parallel port programming for uC's. You can even change
 polarity of control lines without touching the wires using I/O port setup.
 .
 Using Ponyprog together with generic USB2serial adapters is currently
 not possible! There are plans on upstream to use libusb to add such
 functionality.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_HOST_ARCH_OS   ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

ICON_SIZES=128x128 64x64 48x48 32x32 24x24 16x16

# detect the encoding of the file ponyprog.html
HTML_FILE_ENCODING = $(shell file -b --mime-encoding distribution/innosetup/ponyprog.html)
# out of tree build folder for application
DEB_BUILD_DIR=debian/build
# default install folder
INSTDIR=$(CURDIR)/debian/tmp

DEB_PONYPROG_CMAKE_OPTS := \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
	-DUSE_DEBUGGER=ON \
	-DUSE_QT5=ON \
	$(NULL)

%:
	dh $@

override_dh_auto_clean:
	dh_clean
	rm -f SrcPony/version.h
	rm -rf debian/build

override_dh_auto_configure:
	mkdir -p $(DEB_BUILD_DIR)
	####################################
	# configuring PonyProg application #
	####################################
	dh_auto_configure --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR) -- $(DEB_PONYPROG_CMAKE_OPTS)
	# convert ponyprog.html to utf-8 if needed
	if [ "$(HTML_FILE_ENCODING)" != "utf-8" ]; then \
		mv ./distribution/innosetup/ponyprog.html ./distribution/innosetup/ponyprog.html.in ;\
		iconv -f $(HTML_FILE_ENCODING) -t utf8 ./distribution/innosetup/ponyprog.html.in > ./distribution/innosetup/ponyprog.html ;\
	fi

override_dh_auto_build:
	dh_auto_build --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)

override_dh_auto_install:
	###################################
	# installing PonyProg application #
	###################################
	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)
	# remove the shipped icon and create the needed graphic by ourself
	rm -f $(INSTDIR)/usr/share/icons/ponyprog.png
	for size in ${ICON_SIZES}; do \
		mkdir -p $(INSTDIR)/usr/share/icons/hicolor/"$${size}"; \
		convert +antialias -background transparent -resize "$${size}!" $(CURDIR)/icons/ponyprog.svg $(INSTDIR)/usr/share/icons/hicolor/"$${size}"/ponyprog.png; \
	done

## ponyprog 3.1.3%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,10 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 2.8 FATAL_ERROR)
 # CMAKE_POLICY(SET CMP0003 OLD)
 # CMAKE_POLICY(SET CMP0015 OLD)
+
+IF(WIN32)
+    CMAKE_POLICY(SET CMP0020 NEW)
+ENDIF()
 
 # set the Qt version to 4 or 5
 OPTION (USE_QT5 "Using of Qt5 version for compiling" ON)
@@ -57,7 +61,6 @@
 INCLUDE(TestCXXAcceptsFlag)
 INCLUDE(CheckCXXCompilerFlag)
 
-
 SET(TARGET_NAME ponyprog )
 SET(CMAKE_HELPERS_BINARY_DIR ${PROJECT_SOURCE_DIR}/cmake)
 SET(CMAKE_HELPERS_SOURCE_DIR ${PROJECT_SOURCE_DIR}/cmake)
@@ -87,18 +90,24 @@
 
 # Set the PonyProg version
 # this for generating of version file from HISTORY file
-# the idea is to descript all changes in this file, the ne changes are in the top of file
+# the idea is to descript all changes in this file, last changes with version are in the top of file
 FILE(READ "HISTORY" DESCRIBE_STRING)
 STRING(REGEX MATCH "([0-9]+\\.[0-9]+\\.[0-9]+)" APP_VERSION "${DESCRIBE_STRING}" )
 
-MESSAGE(STATUS "Version info: ${APP_VERSION}") 
+MESSAGE(STATUS "Version info: ${APP_VERSION}")
 SET(VERSION ${APP_VERSION})
 
-# 
+#
 # SET(APP_VERSION "3.0.0")
 SET(APP_AUTHOR "Claudio Lanconelli")
 SET(APP_EMAIL "PonyProg2000@gmail.com")
 SET(APP_NAME "PonyProg")
+SET(AUTHORWEB "http://www.LancOS.com")
+SET(APP_YEAR "2022")
+
+SET(PORTERGQT "Eduard Kalinowski")
+SET(PORTERMAIL "eduard_kalinowski@yahoo.de")
+
 
 IF(WIN32)
   EXECUTE_PROCESS (
@@ -107,7 +116,7 @@
     OUTPUT_STRIP_TRAILING_WHITESPACE)
 ELSE()
   EXECUTE_PROCESS (
-    COMMAND date +"%d.%m.%Y"
+    COMMAND date +"%d-%m-%Y"
     OUTPUT_VARIABLE APP_BUILD_DATE
     OUTPUT_STRIP_TRAILING_WHITESPACE)
     STRING(REGEX REPLACE "\"" "" APP_BUILD_DATE ${APP_BUILD_DATE})
@@ -115,10 +124,10 @@
 
 MESSAGE(STATUS "Version build date: ${APP_BUILD_DATE}")
 
-# 
+#
 SET(PONYPROG_PACKAGE ponyprog)
 SET(PONYPROG_HOST ${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR})
-SET(PONYPROG_COPYRIGHT "Copyright (c) 1997-2021   ${APP_AUTHOR}, All Rights Reserved.")
+#SET(PONYPROG_COPYRIGHT "Copyright (c) 1997-${APP_YEAR} ${APP_AUTHOR}, All Rights Reserved.")
 SET(PONYPROG_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
 
 # Setup high-level build options
@@ -135,7 +144,7 @@
 ENDIF()
 
 
-# options for gprof 
+# options for gprof
 IF(${USE_PROFILER})
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
   SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
@@ -178,30 +187,47 @@
     ENDIF(NOT Qt5Multimedia_FOUND)
 ENDIF()
 
-#set ( FTDIPP ON )
-FIND_PACKAGE ( LibFTDI1 NO_MODULE REQUIRED )
-
-IF(NOT LibFTDI1_FOUND)
-    MESSAGE(FATAL_ERROR "LibFTDI1 files are not found. "
-    "LibFTDI1 and LibFTDIPP1 development packages are to install.")
-ENDIF(NOT LibFTDI1_FOUND)
-
-INCLUDE ( ${LIBFTDI_USE_FILE} )
-
-# for this feature install debhelper or 
+IF (NOT WIN32)
+    FIND_PACKAGE ( LibFTDI1 NO_MODULE REQUIRED )
+
+    IF(NOT LibFTDI1_FOUND)
+        MESSAGE(FATAL_ERROR "LibFTDI1 files are not found. "
+        "LibFTDI1 and LibFTDIPP1 development packages are to install.")
+    ENDIF(NOT LibFTDI1_FOUND)
+
+    INCLUDE ( ${LIBFTDI_USE_FILE} )
+ELSE()
+    SET ( BOOST_DIR            "C:/Libraries/boost_1_67_0" )
+    SET ( LIBFTDI_ROOT_DIR     "C:/libftdi1-1.4git_devkit_x86_x64_14June2018" )
+
+	SET ( LIBFTDI_LIBRARY      "ftdi1" )
+    SET ( LIBFTDIPP_LIBRARY    "ftdipp1" )
+
+    SET ( LIBFTDI_VERSION_STRING "1.4" )
+    SET ( LIBFTDI_VERSION_MAJOR  "1" )
+    SET ( LIBFTDI_VERSION_MINOR  "4" )
+
+	INCLUDE_DIRECTORIES("${BOOST_DIR}")
+	INCLUDE_DIRECTORIES("${LIBFTDI_ROOT_DIR}/include")
+	INCLUDE_DIRECTORIES("${LIBFTDI_ROOT_DIR}/include/libftdi")
+	LINK_DIRECTORIES("${LIBFTDI_ROOT_DIR}/lib32")
+ENDIF()
+
+INCLUDE_DIRECTORIES(${LIBUSB_INCLUDE_DIRS})
+
+# for this feature install debhelper or
 SET(PONYPROG_CPACK_PACKAGE_SHLIBDEPS ON)
 
 IF(${USE_QT_VERSION} MATCHES "4")
-    INCLUDE_DIRECTORIES(${QT_INCLUDES} ${LIBUSB_INCLUDE_DIRS})
+    INCLUDE_DIRECTORIES(${QT_INCLUDES})
     MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES}")
 ELSE()
-    INCLUDE_DIRECTORIES(${QT_INCLUDES} ${Qt5Widgets_INCLUDE_DIRS}  ${Qt5PrintSupport_INCLUDE_DIRS} ${Qt5Multimedia_INCLUDE_DIRS} ${LIBUSB_INCLUDE_DIRS})
-
-    MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES} ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Multimedia_INCLUDE_DIRS}")
+    INCLUDE_DIRECTORIES(${QT_INCLUDES} ${Qt5Widgets_INCLUDE_DIRS}  ${Qt5PrintSupport_INCLUDE_DIRS} ${Qt5Multimedia_INCLUDE_DIRS})
+
+    #MESSAGE(STATUS "QT_INCLUDES ${QT_INCLUDES} ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Multimedia_INCLUDE_DIRS}")
 
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} ${Qt5Multimedia_EXECUTABLE_COMPILE_FLAGS} ${Qt5PrintSupport_EXECUTABLE_COMPILE_FLAGS}")
 ENDIF()
-
 
 configure_file (
   "${PROJECT_SOURCE_DIR}/SrcPony/version-cmake.h.in"
@@ -216,7 +242,7 @@
 ADD_SUBDIRECTORY(qhexedit2/src)
 ADD_SUBDIRECTORY(SrcPony)
 
-INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/qhexedit2/src/ ${CMAKE_CURRENT_SOURCE_DIR}/SrcPony/ )
+INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_SOURCE_DIR}/qhexedit2/src/ ${CMAKE_CURRENT_SOURCE_DIR}/SrcPony/ )
 
 
 IF(${USE_QT_VERSION} MATCHES "4")
@@ -234,7 +260,7 @@
 
 MESSAGE(STATUS "PONY_RESOURCES ${APP_RESOURCES_RCC}")
 
-INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
+INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
 
 SOURCE_GROUP( "Generated Files" FILES
     ${MOC_FILES_CPP}
@@ -242,6 +268,12 @@
     ${APP_RESOURCES_RCC}
 )
 
+message(STATUS "Include dirs ")
+get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
+foreach(dir ${dirs})
+  message(STATUS "dir='${dir}'")
+endforeach()
+
 
 IF(NOT ${USE_DEBUGGER})
     ADD_DEFINITIONS(${QT_DEFINITIONS} -DQT_NO_DEBUG_OUTPUT -DQT_NO_DEBUG -DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)
@@ -261,33 +293,35 @@
     ADD_DEFINITIONS(-DUNICODE -D_UNICODE)
 ENDIF()
 
-
-
 ADD_EXECUTABLE(${CMAKE_PROJECT_NAME}
-    ${APP_SOURCES} 
+    ${APP_SOURCES}
     ${HEX_SOURCES}
     ${PONY_SOURCES}
-    ${APP_HEADERS_MOC} 
-    ${APP_FORMS_HEADERS} 
+    ${APP_HEADERS_MOC}
+    ${APP_FORMS_HEADERS}
 #     ${APP_TRANSLATIONS}
     ${APP_RESOURCES_RCC}
 )
 
 
 IF(${USE_QT_VERSION} MATCHES "4")
-  TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} ${LIBUSB_LIBRARIES})
-ELSE()
-  TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES} ${LIBUSB_LIBRARIES})
-  MESSAGE(STATUS "QT LIBRARIES: ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES} ${Qt5Core_LIBRARIES}")
-ENDIF()
-
-#target_link_libraries(${CMAKE_PROJECT_NAME} ${LIBFTDI_LIBRARIES} )
-target_link_libraries(${CMAKE_PROJECT_NAME} ftdipp1 ${LIBFTDI_LIBRARIES} )
+  TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES})
+ELSE()
+  TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES})
+  #MESSAGE(STATUS "QT LIBRARIES: ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES} ${Qt5Core_LIBRARIES}")
+ENDIF()
+
+#TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${LIBFTDI_LIBRARIES} )
+TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} ${LIBFTDIPP_LIBRARY} ${LIBFTDI_LIBRARY} ${LIBUSB_LIBRARIES})
 
 ADD_CUSTOM_TARGET (tags
     COMMAND  ctags -R -f tags ${CMAKE_SOURCE_DIR}/SrcPony
     WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
 )
+
+#message(STATUS "Link Libraries ")
+#get_target_property(OUTP ${CMAKE_PROJECT_NAME} LINK_LIBRARIES)
+#message(STATUS ${OUTP})
 
 
 # Setup module enabled/disabled defaults ...
@@ -340,30 +374,3 @@
 IF(MSVC)
     SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PONYPROG_BINARY_DIR}/bin)
 ELSE(MSVC)
-    SET(PONYPROG_LIBDIR lib) # Allows us to handle 64-bit libs if/when it becomes necessary.
-    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PONYPROG_BINARY_DIR}/${PONYPROG_LIBDIR})
-ENDIF(MSVC)
-
-# Setup a macro for compiling resources ...
-MACRO(PONYPROG_COMPILE_RESOURCE OUTPUT INPUT RESOURCE_PATH)
-
-    SET(INPUT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/${INPUT}")
-    SET(OUTPUT_FILE "${CMAKE_CURRENT_BINARY_DIR}/${INPUT}.cpp")
-    GET_FILENAME_COMPONENT(OUTPUT_PATH ${OUTPUT_FILE} PATH)
-
-    GET_TARGET_PROPERTY(PONYPROG_RESOURCE_COMPILER ponyprog-resource-compiler LOCATION)
-
-    ADD_CUSTOM_COMMAND(
-        DEPENDS ponyprog-resource-compiler
-        DEPENDS ${INPUT_FILE}
-        COMMAND ${CMAKE_COMMAND} -E make_directory ${OUTPUT_PATH}
-        COMMAND ${PONYPROG_RESOURCE_COMPILER} --input ${INPUT_FILE} --path \"<path>${RESOURCE_PATH}</path>\" --output ${OUTPUT_FILE}
-        OUTPUT ${OUTPUT_FILE}
-        COMMENT "Compiling resource ${INPUT_FILE}"
-        )
-
-    LIST(APPEND ${OUTPUT} ${OUTPUT_FILE})
-
-ENDMACRO(PONYPROG_COMPILE_RESOURCE)
-
-# Setup subdirectories ...

=== SrcPony/CMakeLists.txt ===
#CMakeLists.txt

SET(PONY_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/aboutmdlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/usbwatcher.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/Translator.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2app.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at25xxx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at93cbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/crc.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx-1.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx-2.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx-5.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2profil.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/fusemdlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/bitfield.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/blockmdlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/intfbuf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/lpt_io_interf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/pgminter.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/picbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/progoption.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/sernumdlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/x2444.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at17xxx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at89sbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at93cxx8.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/csmfbuf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2cmdw.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2awinfo.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/easyi2c_interf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/i2cbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/ispinterf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/microbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic125xx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/picbusnew.cpp
#                  ${CMAKE_CURRENT_SOURCE_DIR}/retrymdlg.cpp
#                 ${CMAKE_CURRENT_SOURCE_DIR}/ch341a.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/spi-bus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at250bus2.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at89sxx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at93cxx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/device.cpp
#                  ${CMAKE_CURRENT_SOURCE_DIR}/e2cnv.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/eeptypes.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/imbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/linuxsysfsint.cpp
#                  ${CMAKE_CURRENT_SOURCE_DIR}/modaldlg_utilities.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic12bus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/ponyioint.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/rs232int.cpp
#                  ${CMAKE_CURRENT_SOURCE_DIR}/sxbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at250bus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at90sbus.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/binfbuf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/dt006interf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2dlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/filebuf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/infomdlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/lpt_ext_interf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/mpsse_interf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/motsfbuf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic168xx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/portint.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/sde2506.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/wait.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at250xx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/at90sxx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/busio.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2401.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2pfbuf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/filldlg.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/interfconv.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/lptinterf.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/nvm3060.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic16xx.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/x2444bus.cpp
#                  ${CMAKE_CURRENT_SOURCE_DIR}/profile.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/prefdialog.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/sdebus.cpp)


SET(PONY_NOMOC_HEADERS 
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2app.h 
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2awinfo.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/Translator.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/globals.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/device.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/microbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at25xxx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at93cbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/busio.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/dt006interf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/eeptypes.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/ispinterf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/lpt_io_interf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/mpsse_interf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/pgminter.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/picbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/sde2506.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at17xxx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at89sbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at93cxx8.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2401.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2pfbuf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/errcode.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/i2cbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/jdminter.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic125xx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/picbusnew.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/sdebus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/types.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at250bus2.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at89sxx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at93cxx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/crc.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx-1.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2phead.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/filebuf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/imbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/linuxsysfsint.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic12bus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/ponyioint.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/resource.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/wait.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at250bus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at90sbus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/binfbuf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/csmfbuf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx-2.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2profil.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/lpt_ext_interf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/motsfbuf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic168xx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/portint.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/spi-bus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/x2444bus.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at250xx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/at90sxx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/businter.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e24xx-5.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/easyi2c_interf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/intfbuf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/lptinterf.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/nvm3060.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/pic16xx.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/ppuser.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/rs232int.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/x2444.h)


SET(PONY_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/fusemdlg.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/usbwatcher.h 
                 ${CMAKE_CURRENT_SOURCE_DIR}/bitfield.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/filldlg.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/blockmdlg.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2cmdw.h 
#                 ${CMAKE_CURRENT_SOURCE_DIR}/ch341a.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/e2dlg.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/aboutmdlg.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/prefdialog.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/progoption.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/sernumdlg.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/infomdlg.h)


SET(PONY_FORMS  ${CMAKE_CURRENT_SOURCE_DIR}/forms/aboutdlg.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/editdlg.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/bitfield.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/notesdlg.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/e2dlg.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/fusedlg.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/mainwindow.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/osccalibr.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/prefdialog.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/progoption.ui
                ${CMAKE_CURRENT_SOURCE_DIR}/forms/sernumcfg.ui
                PARENT_SCOPE)


SET(PONY_SOURCES ${PONY_SOURCES}
		PARENT_SCOPE)
		
SET(PONY_NOMOC_HEADERS ${PONY_NOMOC_HEADERS}
		PARENT_SCOPE)

SET(PONY_HEADERS ${PONY_HEADERS}
		PARENT_SCOPE)
		
# SET(FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE} ${MAIN_SOURCES} ${MAIN_FORMS} ${MAIN_HEADERS} 
#                  PARENT_SCOPE)

		 
SET(APP_RESOURCES  ${CMAKE_CURRENT_SOURCE_DIR}/ponyprog.qrc
		 PARENT_SCOPE)


# cleanup $build/*.cpp~ on "make clean"
SET_DIRECTORY_PROPERTIES(PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*~")

=== distribution/osx/bundle/CMakeLists.txt ===
# Generate an application bundle (new-style)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/package-binary-bundle.cpack.in ${CMAKE_CURRENT_BINARY_DIR}/package-binary-bundle.cpack)
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in ${CMAKE_CURRENT_BINARY_DIR}/Info.plist @ONLY)
ADD_CUSTOM_TARGET(package-binary-bundle
	${CMAKE_CPACK_COMMAND}
	--config ${CMAKE_CURRENT_BINARY_DIR}/package-binary-bundle.cpack
	)

# Upload the binary bundle to SourceForge for use with the FRS
ADD_CUSTOM_TARGET(upload-binary-bundle
	rsync -avP -e ssh ${CMAKE_CURRENT_BINARY_DIR}/ponyprog-setup-${APP_VERSION}-${CMAKE_SYSTEM_PROCESSOR}.dmg ${PONYPROG_SOURCEFORGE_USERNAME}@frs.sourceforge.net:uploads/
	)

=== debian/changelog ===
ponyprog (3.1.3+ds-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:13:37 +1100

ponyprog (3.1.3+ds-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:30:56 +0000

ponyprog (3.1.3+ds-1) unstable; urgency=medium

  * [6909f06] d/gbp.conf: Update content to filter out
  * [022768c] New upstream version 3.1.3+ds
  * [8e170c2] d/copyright: Update date and copyright years
  * [a3a8ad5] d/control: Increase Standards-Version to 4.6.0
    No further changes needed.
  * [d4954da] d/control: Adding entry Rules-Requires-Root: binary-targets

 -- Carsten Schoenert <c.schoenert@t-online.de>  Thu, 10 Mar 2022 16:33:58 +0100

## ponyprog 3.1.3+ds

=== debian/changelog ===
ponyprog (3.1.3+ds-2) unstable; urgency=medium

  [ Petter Reinholdtsen ]
  * [8b53cd5] d/ponyprog.metainfo.xml: Add Appstream metainfo
    (Closes: #1070082)

  [ Carsten Schoenert ]
  * [336460c] d/control: Reword package long description
    (Closes: #983736)
  * [85c0657] d/control: Bump Standards-Version to 4.7.0
    No further changes needed.
  * [d70058f] d/rules: Make source rebuildable multiple times
    (Closes: #1046762)
  * [ef07f4d] AppStream Data: Add some more information

 -- Carsten Schoenert <c.schoenert@t-online.de>  Thu, 16 May 2024 21:52:08 +0200

ponyprog (3.1.3+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Use udev.pc to place udev files. (Closes: #1058834)

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 22 Apr 2024 03:18:43 +0200

=== debian/control ===
--- 
+++ 
@@ -11,9 +11,12 @@
  libftdi1-dev,
  libftdipp1-dev,
  libusb-dev,
+ pkgconf,
  qtbase5-dev,
  qtmultimedia5-dev,
-Standards-Version: 4.5.1
+ systemd-dev,
+Rules-Requires-Root: binary-targets
+Standards-Version: 4.7.0
 Homepage: https://github.com/lancos/ponyprog
 Vcs-Browser: https://salsa.debian.org/electronics-team/ponyprog
 Vcs-Git: https://salsa.debian.org/electronics-team/ponyprog.git
@@ -30,20 +33,20 @@
  program Wafercard for SAT, eeprom within GSM, TV or CAR-RADIO.
  Furthermore it can be used as a low cost starter kit for PIC and AVR.
  .
- Ponyprog supports AVR, SPI eeprom, AVR micro, 12C bus 8bit eeprom, PIC 
+ PonyProg supports AVR, SPI eeprom, AVR micro, I2C bus 8bit eeprom, PIC
  16 micro, PIC 12 micro, AT89S micro and SDE2506 eeprom family chips.
  .
  You can open any HEX, e2p, mot, csm, rom, eep, bin files and burn them
  to uC or PIC. You can even backup the old program on the chip using
- Ponyprog. Ponyprog enables the user to write, verify and erase data on
+ PonyProg. PonyProg enables the user to write, verify and erase data on
  the microchip.
  .
- Also setting fuse bits and locks using Ponyprog is possible. You can
+ Also setting fuse bits and locks using PonyProg is possible. You can
  save any HEX file to BIN file or eep file, BIN file to HEX file or MOT
- file and vice versa so you can use Ponyprog as converter too. Ponyprog
+ file and vice versa so you can use PonyProg as converter too. PonyProg
  offers serial or parallel port programming for uC's. You can even change
  polarity of control lines without touching the wires using I/O port setup.
  .
- Using Ponyprog together with generic USB2serial adapters is currently
- not possible! There are plans on upstream to use libusb to add such
- functionality.
+ Using PonyProg together with generic USB2serial based on FTDI adapters will
+ work. There are plans on upstream to use libusb to add more USB2serial
+ based functionality.
